package BSS.Controllers;

import BSS.*;

import java.util.*;

public class CashDeskController extends BaseController
{
    private int _y7;
    private LinkedList _query7;
    final static Set Acceptable_Event = new TreeSet();
    final static Set Acceptable_Message = new TreeSet();

    private int _MC_id;

    static
    {
        Acceptable_Event.add(new Integer(EVENT_GLASS_BREAK));

        Acceptable_Message.add(new Integer(MSG_CASHDESK_SEC_ON));
        Acceptable_Message.add(new Integer(MSG_CASHDESK_SEC_OFF));
    }

    //--- Public section ---
    public CashDeskController(int id, Logger logger, Device device)
    {
        super(id, logger, device);
        _query7 = new LinkedList();
    }

    public String toString()
    {
        return "CashDesk#" + ID();
    }

    //--- Controller methods ---
    public void init()
    {
        _query7.clear();
        _y7 = 0;
        Map conf = sysLoadConfig();
        _MC_id = ((Integer)conf.get("MC")).intValue();
    }

    public void run()
    {
        if (!_query7.isEmpty())
        {
            Integer event = (Integer)_query7.removeFirst();
            A7(event.intValue());
        }
        // No sensors to check
    }

    public void envOnEvent(int event_type)
    {
        if (Acceptable_Event.contains(new Integer(event_type)))
        {
            _query7.addLast(new Integer(event_type));
        }
    }

    public Message msgOnReceive(Message msg)
    {
        if (Acceptable_Message.contains(new Integer(msg.code)))
        {
            _query7.addLast(new Integer(msg.code));
        }
        return null;
    }

    //--- Automaton methods ---
    private void A7(int e)
    {
        log_start("A7", _y7, e);
        int y_now = _y7;

        switch (y_now)
        {
          case 0:
            if (e == 10)
            { z28();                                        _y7 = 1; }
            else
            if (e == 19)
            {                                               _y7 = 1; }
          break;

          case 1:
            if (e == 10)
            { z28();                                                 }
            else
            if (e == 20)
            {                                               _y7 = 0; }
          break;
        }

        if (_y7 != y_now)
        {
            switch (_y7)
            {
              case 0:
                z38();
              break;

              case 1:
                z37();
              break;
            }
        }

        log_end("A7", _y7);
    }

    private void z28()
    {
        log_z("z28", "  ");
        msgSend(_MC_id, MSG_RAID);
    }

    private void z37()
    {
        log_z("z37", " ");
        envEnergize(1);
    }

    private void z38()
    {
        log_z("z38", "  ");
        envUnenergize(1);
    }
}
