package BSS;

import java.util.Set;
import java.util.Iterator;

public class Entry
{
    public final static int PASSAGE = 1;
    public final static int DOOR    = 2;
    public final static int GATEWAY = 3;

    private int _id;
    private int _type;
    private boolean _outside;
    private Room _room1;
    private Room _room2;

    public Entry(int id, int type)
    {
        _id = id;
        _type = type;
    }

    public String toString()
    {
        if (PASSAGE == _type)
        {
            return "Passage#" + _id;
        }
        if (DOOR == _type)
        {
            return "Door#" + _id;
        }
        if (GATEWAY == _type)
        {
            return "Gateway#" + _id;
        }
        return "Entry#" + _id;
    }

    public int ID()
    {
        return _id;
    }

    public int getType()
    {
        return _type;
    }

    public boolean isOutside()
    {
        return _outside;
    }

    public Room getFirstRoom()
    {
        return _room1;
    }

    public Room getSecondRoom()
    {
        return _room2;
    }

    public void setRooms(Set rooms)
    {
        if (null == rooms)
        {
            throw new IllegalArgumentException("Null rooms.");
        }
        int size = rooms.size();
        if ((size < 1) || (size > 2))
        {
            throw new IllegalArgumentException("Invalid number of rooms.");
        }
        _outside = (1 == size);
        Iterator it = rooms.iterator();
        _room1 = (Room)it.next();
        _room2 = _outside ? null : (Room)it.next();
    }
}
