package BSS;

import java.util.Set;

public class Room
{
    public final static int PUBLIC_PLACE     = 1;
    public final static int CLIENTS_ROOM     = 2;
    public final static int STAFF_ROOM       = 3;
    public final static int STORAGE          = 4;
    public final static int LIFT             = 5;

    private int _id;
    private int _type;
    private int _floor;
    private Set _entries;

    public Room(int id, int type, int floor)
    {
        _id = id;
        _type = type;
        _floor = floor;
    }

    public String toString()
    {
        if (PUBLIC_PLACE == _type)
        {
            return "PublicRoom#" + _id;
        }
        if (CLIENTS_ROOM == _type)
        {
            return "ClientRoom#" + _id;
        }
        if (STAFF_ROOM == _type)
        {
            return "StaffRoom#" + _id;
        }
        if (STORAGE == _type)
        {
            return "Storage#" + _id;
        }
        if (LIFT == _type)
        {
            return "Lift#" + _id;
        }
        return "Room#" + _id;
    }

    public int ID()
    {
        return _id;
    }

    public int getType()
    {
        return _type;
    }

    public int getFloor()
    {
        return _floor;
    }

    public Set getEntries()
    {
        return _entries;
    }

    public void setEntries(Set entries)
    {
        if (null == entries)
        {
            throw new IllegalArgumentException("Null entries.");
        }
        _entries = entries;
    }
}
