package BSS;

public class Service
{
    public final static int CASH_MACHINE = 1;
    public final static int CASH_DESK    = 2;
    public final static int PARKING      = 3;

    private int _id;
    private int  _type;
    private Room _room;

    public Service(int id, int type)
    {
        _id = id;
        _type = type;
    }

    public String toString()
    {
        if (CASH_MACHINE == _type)
        {
            return "CashMachine#" + _id;
        }
        if (CASH_DESK == _type)
        {
            return "CashDesk#" + _id;
        }
        if (PARKING == _type)
        {
            return "Parking#" + _id;
        }
        return "Service#" + _id;
    }

    public int ID()
    {
        return _id;
    }

    public int getType()
    {
        return _type;
    }

    public Room getRoom()
    {
        return _room;
    }

    public void setRoom(Room room)
    {
        if (null == room)
        {
            throw new IllegalArgumentException("Null room.");
        }
        _room = room;
    }
}
