package BSS.Simulator;

import BSS.Logger;

import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.PrintStream;

public class XML_Logger implements Logger
{
    int _debug_level;
    SimpleDateFormat _df;
    PrintStream _out;

    public XML_Logger(int debug_level, String date_format, PrintStream o_stream)
    {
        _debug_level = debug_level;
        _df = new SimpleDateFormat(date_format);
        _out = o_stream;
    }

    public void start_log()
    {
        _out.println("<?xml version='1.0' encoding='windows-1251'?>");
        _out.println();
        _out.println("<log>");
    }

    public void end_log()
    {
        _out.println("</log>");
    }

    public void log(int level, String message)
    {
        if (level <= _debug_level)
        {
            _out.println("  <rec timestamp=\"" + _df.format(new Date()) + "\" level=\"" + level + "\">" + message + "</rec>");
        }
    }
}
